##// END OF EJS Templates
a
Unknown -
r549:e4ed07b70aeb
parent child
Show More
@@ -1,884 +1,884
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 # Kernel Branch
48 # Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62
62
63
63
64 # Kernel deb packages for 32bit kernel
64 # Kernel deb packages for 32bit kernel
65 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
69 # Default precompiled 64bit kernel
69 # Default precompiled 64bit kernel
70 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
71 # Generic
71 # Generic
72 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
73 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
74 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
75
75
76 # Build directories
76 # Build directories
77 WORKDIR=$(pwd)
77 WORKDIR=$(pwd)
78 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
79 BUILDDIR="${BASEDIR}/build"
79 BUILDDIR="${BASEDIR}/build"
80
80
81 # Chroot directories
81 # Chroot directories
82 R="${BUILDDIR}/chroot"
82 R="${BUILDDIR}/chroot"
83 ETC_DIR="${R}/etc"
83 ETC_DIR="${R}/etc"
84 LIB_DIR="${R}/lib"
84 LIB_DIR="${R}/lib"
85 BOOT_DIR="${R}/boot/firmware"
85 BOOT_DIR="${R}/boot/firmware"
86 KERNEL_DIR="${R}/usr/src/linux"
86 KERNEL_DIR="${R}/usr/src/linux"
87 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
88 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
89
89
90 # Firmware directory: Blank if download from github
90 # Firmware directory: Blank if download from github
91 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
92
92
93 # General settings
93 # General settings
94 SET_ARCH=${SET_ARCH:=32}
94 SET_ARCH=${SET_ARCH:=32}
95 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
96 PASSWORD=${PASSWORD:=raspberry}
96 PASSWORD=${PASSWORD:=raspberry}
97 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 USER_PASSWORD=${USER_PASSWORD:=raspberry}
98 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
99 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
100 EXPANDROOT=${EXPANDROOT:=true}
100 EXPANDROOT=${EXPANDROOT:=true}
101
101
102 # Keyboard settings
102 # Keyboard settings
103 XKB_MODEL=${XKB_MODEL:=""}
103 XKB_MODEL=${XKB_MODEL:=""}
104 XKB_LAYOUT=${XKB_LAYOUT:=""}
104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 XKB_VARIANT=${XKB_VARIANT:=""}
105 XKB_VARIANT=${XKB_VARIANT:=""}
106 XKB_OPTIONS=${XKB_OPTIONS:=""}
106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107
107
108 # Network settings (DHCP)
108 # Network settings (DHCP)
109 ENABLE_DHCP=${ENABLE_DHCP:=true}
109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110
110
111 # Network settings (static)
111 # Network settings (static)
112 NET_ADDRESS=${NET_ADDRESS:=""}
112 NET_ADDRESS=${NET_ADDRESS:=""}
113 NET_GATEWAY=${NET_GATEWAY:=""}
113 NET_GATEWAY=${NET_GATEWAY:=""}
114 NET_DNS_1=${NET_DNS_1:=""}
114 NET_DNS_1=${NET_DNS_1:=""}
115 NET_DNS_2=${NET_DNS_2:=""}
115 NET_DNS_2=${NET_DNS_2:=""}
116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 NET_NTP_1=${NET_NTP_1:=""}
117 NET_NTP_1=${NET_NTP_1:=""}
118 NET_NTP_2=${NET_NTP_2:=""}
118 NET_NTP_2=${NET_NTP_2:=""}
119
119
120 # APT settings
120 # APT settings
121 APT_PROXY=${APT_PROXY:=""}
121 APT_PROXY=${APT_PROXY:=""}
122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123
123
124 # Feature settings
124 # Feature settings
125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 ENABLE_I2C=${ENABLE_I2C:=false}
129 ENABLE_I2C=${ENABLE_I2C:=false}
130 ENABLE_SPI=${ENABLE_SPI:=false}
130 ENABLE_SPI=${ENABLE_SPI:=false}
131 ENABLE_IPV6=${ENABLE_IPV6:=true}
131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 ENABLE_SSHD=${ENABLE_SSHD:=true}
132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 ENABLE_SOUND=${ENABLE_SOUND:=true}
135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 ENABLE_DBUS=${ENABLE_DBUS:=true}
136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 ENABLE_XORG=${ENABLE_XORG:=false}
139 ENABLE_XORG=${ENABLE_XORG:=false}
140 ENABLE_WM=${ENABLE_WM:=""}
140 ENABLE_WM=${ENABLE_WM:=""}
141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 ENABLE_USER=${ENABLE_USER:=true}
142 ENABLE_USER=${ENABLE_USER:=true}
143 USER_NAME=${USER_NAME:="pi"}
143 USER_NAME=${USER_NAME:="pi"}
144 ENABLE_ROOT=${ENABLE_ROOT:=false}
144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 ENABLE_QEMU=${ENABLE_QEMU:=false}
145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
148
148
149 # SSH settings
149 # SSH settings
150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155
155
156 # Advanced settings
156 # Advanced settings
157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
174 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
175
175
176 # Kernel compilation settings
176 # Kernel compilation settings
177 BUILD_KERNEL=${BUILD_KERNEL:=true}
177 BUILD_KERNEL=${BUILD_KERNEL:=true}
178 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
178 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
179 KERNEL_THREADS=${KERNEL_THREADS:=1}
179 KERNEL_THREADS=${KERNEL_THREADS:=1}
180 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
180 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
181 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
181 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
182 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
182 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
183 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
183 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
184 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
184 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
185 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
185 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
186 KERNEL_VIRT=${KERNEL_VIRT:=false}
186 KERNEL_VIRT=${KERNEL_VIRT:=false}
187 KERNEL_BPF=${KERNEL_BPF:=false}
187 KERNEL_BPF=${KERNEL_BPF:=false}
188 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
188 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
189 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
189 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
190 KERNEL_NF=${KERNEL_NF:=false}
190 KERNEL_NF=${KERNEL_NF:=false}
191
191
192 # Kernel compilation from source directory settings
192 # Kernel compilation from source directory settings
193 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
193 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
194 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
194 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
195 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
195 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
196 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
196 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
197
197
198 # Reduce disk usage settings
198 # Reduce disk usage settings
199 REDUCE_APT=${REDUCE_APT:=true}
199 REDUCE_APT=${REDUCE_APT:=true}
200 REDUCE_DOC=${REDUCE_DOC:=true}
200 REDUCE_DOC=${REDUCE_DOC:=true}
201 REDUCE_MAN=${REDUCE_MAN:=true}
201 REDUCE_MAN=${REDUCE_MAN:=true}
202 REDUCE_VIM=${REDUCE_VIM:=false}
202 REDUCE_VIM=${REDUCE_VIM:=false}
203 REDUCE_BASH=${REDUCE_BASH:=false}
203 REDUCE_BASH=${REDUCE_BASH:=false}
204 REDUCE_HWDB=${REDUCE_HWDB:=true}
204 REDUCE_HWDB=${REDUCE_HWDB:=true}
205 REDUCE_SSHD=${REDUCE_SSHD:=true}
205 REDUCE_SSHD=${REDUCE_SSHD:=true}
206 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
206 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
207
207
208 # Encrypted filesystem settings
208 # Encrypted filesystem settings
209 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
209 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
210 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
210 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
211 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
211 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
212 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
212 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
213 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
213 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
214 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
214 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
215 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
215 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
216 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
216 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
217 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
217 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
218
218
219 # Chroot scripts directory
219 # Chroot scripts directory
220 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
220 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
221
221
222 # Packages required in the chroot build environment
222 # Packages required in the chroot build environment
223 APT_INCLUDES=${APT_INCLUDES:=""}
223 APT_INCLUDES=${APT_INCLUDES:=""}
224 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
224 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
225
225
226 # Packages to exclude from chroot build environment
226 # Packages to exclude from chroot build environment
227 APT_EXCLUDES=${APT_EXCLUDES:=""}
227 APT_EXCLUDES=${APT_EXCLUDES:=""}
228
228
229 # Packages required for bootstrapping
229 # Packages required for bootstrapping
230 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
230 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
231 MISSING_PACKAGES=""
231 MISSING_PACKAGES=""
232
232
233 # Packages installed for c/c++ build environment in chroot (keep empty)
233 # Packages installed for c/c++ build environment in chroot (keep empty)
234 COMPILER_PACKAGES=""
234 COMPILER_PACKAGES=""
235
235
236 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
236 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
237 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
237 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
238 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
238 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
239 APT_PROXY=http://127.0.0.1:3142/
239 APT_PROXY=http://127.0.0.1:3142/
240 fi
240 fi
241
241
242 # netselect-apt does not know buster yet
242 # netselect-apt does not know buster yet
243 if [ "$RELEASE" = "buster" ] ; then
243 if [ "$RELEASE" = "buster" ] ; then
244 RLS=testing
244 RLS=testing
245 else
245 else
246 RLS="$RELEASE"
246 RLS="$RELEASE"
247 fi
247 fi
248
248
249 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
249 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
250 rm "$(pwd)/files/apt/sources.list"
250 rm "$(pwd)/files/apt/sources.list"
251 fi
251 fi
252
252
253 if [ "$ENABLE_NONFREE" = true ] ; then
253 if [ "$ENABLE_NONFREE" = true ] ; then
254 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
254 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
255 else
255 else
256 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
256 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
257 fi
257 fi
258
258
259 # sed and cut the result string so we can use it as APT_SERVER
259 # sed and cut the result string so we can use it as APT_SERVER
260 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
260 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
261
261
262 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
262 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
263 if [ -n "$SET_ARCH" ] ; then
263 if [ -n "$SET_ARCH" ] ; then
264 # 64-bit configuration
264 # 64-bit configuration
265 if [ "$SET_ARCH" = 64 ] ; then
265 if [ "$SET_ARCH" = 64 ] ; then
266 # General 64-bit depended settings
266 # General 64-bit depended settings
267 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
267 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
268 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
268 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
269 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
269 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
270
270
271 # Raspberry Pi model specific settings
271 # Raspberry Pi model specific settings
272 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
272 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
274 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
274 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
278 else
278 else
279 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
279 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
280 exit 1
280 exit 1
281 fi
281 fi
282 fi
282 fi
283
283
284 # 32-bit configuration
284 # 32-bit configuration
285 if [ "$SET_ARCH" = 32 ] ; then
285 if [ "$SET_ARCH" = 32 ] ; then
286 # General 32-bit dependend settings
286 # General 32-bit dependend settings
287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
290
290
291 # Raspberry Pi model specific settings
291 # Raspberry Pi model specific settings
292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
295 RELEASE_ARCH=${RELEASE_ARCH:=armel}
295 RELEASE_ARCH=${RELEASE_ARCH:=armel}
296 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
296 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
297 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
297 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
298 fi
298 fi
299
299
300 # Raspberry Pi model specific settings
300 # Raspberry Pi model specific settings
301 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
301 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
307 fi
307 fi
308 fi
308 fi
309 # SET_ARCH not set
309 # SET_ARCH not set
310 else
310 else
311 echo "error: Please set '32' or '64' as value for SET_ARCH"
311 echo "error: Please set '32' or '64' as value for SET_ARCH"
312 exit 1
312 exit 1
313 fi
313 fi
314 # Device specific configuration and U-Boot configuration
314 # Device specific configuration and U-Boot configuration
315 case "$RPI_MODEL" in
315 case "$RPI_MODEL" in
316 0)
316 0)
317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
319 ;;
319 ;;
320 1)
320 1)
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 ;;
323 ;;
324 1P)
324 1P)
325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 ;;
327 ;;
328 2)
328 2)
329 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
329 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
331 ;;
331 ;;
332 3)
332 3)
333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
335 ;;
335 ;;
336 3P)
336 3P)
337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 ;;
339 ;;
340 *)
340 *)
341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
342 exit 1
342 exit 1
343 ;;
343 ;;
344 esac
344 esac
345
345
346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
348 # Include bluetooth packages on supported boards
348 # Include bluetooth packages on supported boards
349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
351 fi
351 fi
352 if [ "$ENABLE_WIRELESS" = true ] ; then
352 if [ "$ENABLE_WIRELESS" = true ] ; then
353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
354 fi
354 fi
355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
356 # Check if the internal wireless interface is not supported by the RPi model
356 # Check if the internal wireless interface is not supported by the RPi model
357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
359 exit 1
359 exit 1
360 fi
360 fi
361 fi
361 fi
362
362
363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
365 exit 1
365 exit 1
366 fi
366 fi
367
367
368 # Prepare date string for default image file name
368 # Prepare date string for default image file name
369 DATE="$(date +%Y-%m-%d)"
369 DATE="$(date +%Y-%m-%d)"
370 if [ -z "$KERNEL_BRANCH" ] ; then
370 if [ -z "$KERNEL_BRANCH" ] ; then
371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
372 else
372 else
373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
374 fi
374 fi
375
375
376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
380 exit 1
380 exit 1
381 fi
381 fi
382 fi
382 fi
383
383
384 set +x
384 set +x
385
385
386 # Add cmake to compile videocore sources
386 # Add cmake to compile videocore sources
387 if [ "$ENABLE_KEYGEN" = true ] ; then
387 if [ "$ENABLE_KEYGEN" = true ] ; then
388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
389 fi
389 fi
390
390
391 # Add cmake to compile videocore sources
391 # Add cmake to compile videocore sources
392 if [ "$ENABLE_VIDEOCORE" = true ] ; then
392 if [ "$ENABLE_VIDEOCORE" = true ] ; then
393 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
393 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
394 fi
394 fi
395
395
396 # Add deps for nexmon
396 # Add deps for nexmon
397 if [ "$ENABLE_NEXMON" = true ] ; then
397 if [ "$ENABLE_NEXMON" = true ] ; then
398 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
398 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
399 fi
399 fi
400
400
401 # Add libncurses5 to enable kernel menuconfig
401 # Add libncurses5 to enable kernel menuconfig
402 if [ "$KERNEL_MENUCONFIG" = true ] ; then
402 if [ "$KERNEL_MENUCONFIG" = true ] ; then
403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
404 fi
404 fi
405
405
406 # Add ccache compiler cache for (faster) kernel cross (re)compilation
406 # Add ccache compiler cache for (faster) kernel cross (re)compilation
407 if [ "$KERNEL_CCACHE" = true ] ; then
407 if [ "$KERNEL_CCACHE" = true ] ; then
408 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
408 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
409 fi
409 fi
410
410
411 # Add cryptsetup package to enable filesystem encryption
411 # Add cryptsetup package to enable filesystem encryption
412 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
412 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
413 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
413 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
414 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
414 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
415
415
416 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
416 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
417 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
417 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
418 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
418 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
419 fi
419 fi
420
420
421 if [ -z "$CRYPTFS_PASSWORD" ] ; then
421 if [ -z "$CRYPTFS_PASSWORD" ] ; then
422 echo "error: no password defined (CRYPTFS_PASSWORD)!"
422 echo "error: no password defined (CRYPTFS_PASSWORD)!"
423 exit 1
423 exit 1
424 fi
424 fi
425 ENABLE_INITRAMFS=true
425 ENABLE_INITRAMFS=true
426 fi
426 fi
427
427
428 # Add initramfs generation tools
428 # Add initramfs generation tools
429 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
429 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
430 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
430 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
431 fi
431 fi
432
432
433 # Add device-tree-compiler required for building the U-Boot bootloader
433 # Add device-tree-compiler required for building the U-Boot bootloader
434 if [ "$ENABLE_UBOOT" = true ] ; then
434 if [ "$ENABLE_UBOOT" = true ] ; then
435 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
435 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
436 fi
436 fi
437
437
438 if [ "$ENABLE_USBBOOT" = true ] ; then
438 if [ "$ENABLE_USBBOOT" = true ] ; then
439 if ! [ "$RPI_MODEL" = 3 ] || ! [ "$RPI_MODEL" = 3P ] ; then
439 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
440 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
440 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
441 exit 1
441 exit 1
442 fi
442 fi
443 fi
443 fi
444
444
445 # Check if root SSH (v2) public key file exists
445 # Check if root SSH (v2) public key file exists
446 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
446 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
447 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
447 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
448 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
448 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
449 exit 1
449 exit 1
450 fi
450 fi
451 fi
451 fi
452
452
453 # Check if $USER_NAME SSH (v2) public key file exists
453 # Check if $USER_NAME SSH (v2) public key file exists
454 if [ -n "$SSH_USER_PUB_KEY" ] ; then
454 if [ -n "$SSH_USER_PUB_KEY" ] ; then
455 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
455 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
456 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
456 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
457 exit 1
457 exit 1
458 fi
458 fi
459 fi
459 fi
460
460
461 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
461 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
462 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
462 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
463 exit 1
463 exit 1
464 fi
464 fi
465
465
466 # Check if all required packages are installed on the build system
466 # Check if all required packages are installed on the build system
467 for package in $REQUIRED_PACKAGES ; do
467 for package in $REQUIRED_PACKAGES ; do
468 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
468 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
469 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
469 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
470 fi
470 fi
471 done
471 done
472
472
473 # If there are missing packages ask confirmation for install, or exit
473 # If there are missing packages ask confirmation for install, or exit
474 if [ -n "$MISSING_PACKAGES" ] ; then
474 if [ -n "$MISSING_PACKAGES" ] ; then
475 echo "the following packages needed by this script are not installed:"
475 echo "the following packages needed by this script are not installed:"
476 echo "$MISSING_PACKAGES"
476 echo "$MISSING_PACKAGES"
477
477
478 printf "\ndo you want to install the missing packages right now? [y/n] "
478 printf "\ndo you want to install the missing packages right now? [y/n] "
479 read -r confirm
479 read -r confirm
480 [ "$confirm" != "y" ] && exit 1
480 [ "$confirm" != "y" ] && exit 1
481
481
482 # Make sure all missing required packages are installed
482 # Make sure all missing required packages are installed
483 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
483 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
484 fi
484 fi
485
485
486 # Check if ./bootstrap.d directory exists
486 # Check if ./bootstrap.d directory exists
487 if [ ! -d "./bootstrap.d/" ] ; then
487 if [ ! -d "./bootstrap.d/" ] ; then
488 echo "error: './bootstrap.d' required directory not found!"
488 echo "error: './bootstrap.d' required directory not found!"
489 exit 1
489 exit 1
490 fi
490 fi
491
491
492 # Check if ./files directory exists
492 # Check if ./files directory exists
493 if [ ! -d "./files/" ] ; then
493 if [ ! -d "./files/" ] ; then
494 echo "error: './files' required directory not found!"
494 echo "error: './files' required directory not found!"
495 exit 1
495 exit 1
496 fi
496 fi
497
497
498 # Check if specified KERNELSRC_DIR directory exists
498 # Check if specified KERNELSRC_DIR directory exists
499 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
499 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
500 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
500 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
501 exit 1
501 exit 1
502 fi
502 fi
503
503
504 # Check if specified UBOOTSRC_DIR directory exists
504 # Check if specified UBOOTSRC_DIR directory exists
505 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
505 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
506 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
506 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
507 exit 1
507 exit 1
508 fi
508 fi
509
509
510 # Check if specified VIDEOCORESRC_DIR directory exists
510 # Check if specified VIDEOCORESRC_DIR directory exists
511 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
511 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
512 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
512 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
513 exit 1
513 exit 1
514 fi
514 fi
515
515
516 # Check if specified FBTURBOSRC_DIR directory exists
516 # Check if specified FBTURBOSRC_DIR directory exists
517 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
517 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
518 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
518 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
519 exit 1
519 exit 1
520 fi
520 fi
521
521
522 # Check if specified NEXMONSRC_DIR directory exists
522 # Check if specified NEXMONSRC_DIR directory exists
523 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
523 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
524 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
524 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
525 exit 1
525 exit 1
526 fi
526 fi
527
527
528 # Check if specified CHROOT_SCRIPTS directory exists
528 # Check if specified CHROOT_SCRIPTS directory exists
529 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
529 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
530 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
530 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
531 exit 1
531 exit 1
532 fi
532 fi
533
533
534 # Check if specified device mapping already exists (will be used by cryptsetup)
534 # Check if specified device mapping already exists (will be used by cryptsetup)
535 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
535 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
536 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
536 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
537 exit 1
537 exit 1
538 fi
538 fi
539
539
540 # Don't clobber an old build
540 # Don't clobber an old build
541 if [ -e "$BUILDDIR" ] ; then
541 if [ -e "$BUILDDIR" ] ; then
542 echo "error: directory ${BUILDDIR} already exists, not proceeding"
542 echo "error: directory ${BUILDDIR} already exists, not proceeding"
543 exit 1
543 exit 1
544 fi
544 fi
545
545
546 # Setup chroot directory
546 # Setup chroot directory
547 mkdir -p "${R}"
547 mkdir -p "${R}"
548
548
549 # Check if build directory has enough of free disk space >512MB
549 # Check if build directory has enough of free disk space >512MB
550 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
550 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
551 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
551 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
552 exit 1
552 exit 1
553 fi
553 fi
554
554
555 set -x
555 set -x
556
556
557 # Call "cleanup" function on various signals and errors
557 # Call "cleanup" function on various signals and errors
558 trap cleanup 0 1 2 3 6
558 trap cleanup 0 1 2 3 6
559
559
560 # Add required packages for the minbase installation
560 # Add required packages for the minbase installation
561 if [ "$ENABLE_MINBASE" = true ] ; then
561 if [ "$ENABLE_MINBASE" = true ] ; then
562 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
562 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
563 fi
563 fi
564
564
565 # Add parted package, required to get partprobe utility
565 # Add parted package, required to get partprobe utility
566 if [ "$EXPANDROOT" = true ] ; then
566 if [ "$EXPANDROOT" = true ] ; then
567 APT_INCLUDES="${APT_INCLUDES},parted"
567 APT_INCLUDES="${APT_INCLUDES},parted"
568 fi
568 fi
569
569
570 # Add dbus package, recommended if using systemd
570 # Add dbus package, recommended if using systemd
571 if [ "$ENABLE_DBUS" = true ] ; then
571 if [ "$ENABLE_DBUS" = true ] ; then
572 APT_INCLUDES="${APT_INCLUDES},dbus"
572 APT_INCLUDES="${APT_INCLUDES},dbus"
573 fi
573 fi
574
574
575 # Add iptables IPv4/IPv6 package
575 # Add iptables IPv4/IPv6 package
576 if [ "$ENABLE_IPTABLES" = true ] ; then
576 if [ "$ENABLE_IPTABLES" = true ] ; then
577 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
577 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
578 fi
578 fi
579 # Add apparmor for KERNEL_SECURITY
579 # Add apparmor for KERNEL_SECURITY
580 if [ "$KERNEL_SECURITY" = true ] ; then
580 if [ "$KERNEL_SECURITY" = true ] ; then
581 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
581 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
582 fi
582 fi
583
583
584 # Add openssh server package
584 # Add openssh server package
585 if [ "$ENABLE_SSHD" = true ] ; then
585 if [ "$ENABLE_SSHD" = true ] ; then
586 APT_INCLUDES="${APT_INCLUDES},openssh-server"
586 APT_INCLUDES="${APT_INCLUDES},openssh-server"
587 fi
587 fi
588
588
589 # Add alsa-utils package
589 # Add alsa-utils package
590 if [ "$ENABLE_SOUND" = true ] ; then
590 if [ "$ENABLE_SOUND" = true ] ; then
591 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
591 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
592 fi
592 fi
593
593
594 # Add rng-tools package
594 # Add rng-tools package
595 if [ "$ENABLE_HWRANDOM" = true ] ; then
595 if [ "$ENABLE_HWRANDOM" = true ] ; then
596 APT_INCLUDES="${APT_INCLUDES},rng-tools"
596 APT_INCLUDES="${APT_INCLUDES},rng-tools"
597 fi
597 fi
598
598
599 # Add fbturbo video driver
599 # Add fbturbo video driver
600 if [ "$ENABLE_FBTURBO" = true ] ; then
600 if [ "$ENABLE_FBTURBO" = true ] ; then
601 # Enable xorg package dependencies
601 # Enable xorg package dependencies
602 ENABLE_XORG=true
602 ENABLE_XORG=true
603 fi
603 fi
604
604
605 # Add user defined window manager package
605 # Add user defined window manager package
606 if [ -n "$ENABLE_WM" ] ; then
606 if [ -n "$ENABLE_WM" ] ; then
607 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
607 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
608
608
609 # Enable xorg package dependencies
609 # Enable xorg package dependencies
610 ENABLE_XORG=true
610 ENABLE_XORG=true
611 fi
611 fi
612
612
613 # Add xorg package
613 # Add xorg package
614 if [ "$ENABLE_XORG" = true ] ; then
614 if [ "$ENABLE_XORG" = true ] ; then
615 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
615 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
616 fi
616 fi
617
617
618 # Replace selected packages with smaller clones
618 # Replace selected packages with smaller clones
619 if [ "$ENABLE_REDUCE" = true ] ; then
619 if [ "$ENABLE_REDUCE" = true ] ; then
620 # Add levee package instead of vim-tiny
620 # Add levee package instead of vim-tiny
621 if [ "$REDUCE_VIM" = true ] ; then
621 if [ "$REDUCE_VIM" = true ] ; then
622 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
622 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
623 fi
623 fi
624
624
625 # Add dropbear package instead of openssh-server
625 # Add dropbear package instead of openssh-server
626 if [ "$REDUCE_SSHD" = true ] ; then
626 if [ "$REDUCE_SSHD" = true ] ; then
627 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
627 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
628 fi
628 fi
629 fi
629 fi
630
630
631 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
631 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
632 if [ "$ENABLE_SYSVINIT" = false ] ; then
632 if [ "$ENABLE_SYSVINIT" = false ] ; then
633 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
633 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
634 fi
634 fi
635
635
636 # Configure kernel sources if no KERNELSRC_DIR
636 # Configure kernel sources if no KERNELSRC_DIR
637 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
637 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
638 KERNELSRC_CONFIG=true
638 KERNELSRC_CONFIG=true
639 fi
639 fi
640
640
641 # Configure reduced kernel
641 # Configure reduced kernel
642 if [ "$KERNEL_REDUCE" = true ] ; then
642 if [ "$KERNEL_REDUCE" = true ] ; then
643 KERNELSRC_CONFIG=false
643 KERNELSRC_CONFIG=false
644 fi
644 fi
645
645
646 # Configure qemu compatible kernel
646 # Configure qemu compatible kernel
647 if [ "$ENABLE_QEMU" = true ] ; then
647 if [ "$ENABLE_QEMU" = true ] ; then
648 DTB_FILE=vexpress-v2p-ca15_a7.dtb
648 DTB_FILE=vexpress-v2p-ca15_a7.dtb
649 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
649 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
650 KERNEL_DEFCONFIG="vexpress_defconfig"
650 KERNEL_DEFCONFIG="vexpress_defconfig"
651 if [ "$KERNEL_MENUCONFIG" = false ] ; then
651 if [ "$KERNEL_MENUCONFIG" = false ] ; then
652 KERNEL_OLDDEFCONFIG=true
652 KERNEL_OLDDEFCONFIG=true
653 fi
653 fi
654 fi
654 fi
655
655
656 # Execute bootstrap scripts
656 # Execute bootstrap scripts
657 for SCRIPT in bootstrap.d/*.sh; do
657 for SCRIPT in bootstrap.d/*.sh; do
658 head -n 3 "$SCRIPT"
658 head -n 3 "$SCRIPT"
659 . "$SCRIPT"
659 . "$SCRIPT"
660 done
660 done
661
661
662 ## Execute custom bootstrap scripts
662 ## Execute custom bootstrap scripts
663 if [ -d "custom.d" ] ; then
663 if [ -d "custom.d" ] ; then
664 for SCRIPT in custom.d/*.sh; do
664 for SCRIPT in custom.d/*.sh; do
665 . "$SCRIPT"
665 . "$SCRIPT"
666 done
666 done
667 fi
667 fi
668
668
669 # Execute custom scripts inside the chroot
669 # Execute custom scripts inside the chroot
670 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
670 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
671 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
671 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
672 chroot_exec /bin/bash -x <<'EOF'
672 chroot_exec /bin/bash -x <<'EOF'
673 for SCRIPT in /chroot_scripts/* ; do
673 for SCRIPT in /chroot_scripts/* ; do
674 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
674 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
675 $SCRIPT
675 $SCRIPT
676 fi
676 fi
677 done
677 done
678 EOF
678 EOF
679 rm -rf "${R}/chroot_scripts"
679 rm -rf "${R}/chroot_scripts"
680 fi
680 fi
681
681
682 # Remove c/c++ build environment from the chroot
682 # Remove c/c++ build environment from the chroot
683 chroot_remove_cc
683 chroot_remove_cc
684
684
685 # Generate required machine-id
685 # Generate required machine-id
686 MACHINE_ID=$(dbus-uuidgen)
686 MACHINE_ID=$(dbus-uuidgen)
687 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
687 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
688 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
688 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
689
689
690 # APT Cleanup
690 # APT Cleanup
691 chroot_exec apt-get -y clean
691 chroot_exec apt-get -y clean
692 chroot_exec apt-get -y autoclean
692 chroot_exec apt-get -y autoclean
693 chroot_exec apt-get -y autoremove
693 chroot_exec apt-get -y autoremove
694
694
695 # Unmount mounted filesystems
695 # Unmount mounted filesystems
696 umount -l "${R}/proc"
696 umount -l "${R}/proc"
697 umount -l "${R}/sys"
697 umount -l "${R}/sys"
698
698
699 # Clean up directories
699 # Clean up directories
700 rm -rf "${R}/run/*"
700 rm -rf "${R}/run/*"
701 rm -rf "${R}/tmp/*"
701 rm -rf "${R}/tmp/*"
702
702
703 # Clean up files
703 # Clean up files
704 rm -f "${ETC_DIR}/ssh/ssh_host_*"
704 rm -f "${ETC_DIR}/ssh/ssh_host_*"
705 rm -f "${ETC_DIR}/dropbear/dropbear_*"
705 rm -f "${ETC_DIR}/dropbear/dropbear_*"
706 rm -f "${ETC_DIR}/apt/sources.list.save"
706 rm -f "${ETC_DIR}/apt/sources.list.save"
707 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
707 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
708 rm -f "${ETC_DIR}/*-"
708 rm -f "${ETC_DIR}/*-"
709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
710 rm -f "${ETC_DIR}/resolv.conf"
710 rm -f "${ETC_DIR}/resolv.conf"
711 rm -f "${R}/root/.bash_history"
711 rm -f "${R}/root/.bash_history"
712 rm -f "${R}/var/lib/urandom/random-seed"
712 rm -f "${R}/var/lib/urandom/random-seed"
713 rm -f "${R}/initrd.img"
713 rm -f "${R}/initrd.img"
714 rm -f "${R}/vmlinuz"
714 rm -f "${R}/vmlinuz"
715 rm -f "${R}${QEMU_BINARY}"
715 rm -f "${R}${QEMU_BINARY}"
716
716
717 if [ "$ENABLE_QEMU" = true ] ; then
717 if [ "$ENABLE_QEMU" = true ] ; then
718 # Setup QEMU directory
718 # Setup QEMU directory
719 mkdir "${BASEDIR}/qemu"
719 mkdir "${BASEDIR}/qemu"
720
720
721 # Copy kernel image to QEMU directory
721 # Copy kernel image to QEMU directory
722 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
722 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
723
723
724 # Copy kernel config to QEMU directory
724 # Copy kernel config to QEMU directory
725 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
725 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
726
726
727 # Copy kernel dtbs to QEMU directory
727 # Copy kernel dtbs to QEMU directory
728 for dtb in "${BOOT_DIR}/"*.dtb ; do
728 for dtb in "${BOOT_DIR}/"*.dtb ; do
729 if [ -f "${dtb}" ] ; then
729 if [ -f "${dtb}" ] ; then
730 install_readonly "${dtb}" "${BASEDIR}/qemu/"
730 install_readonly "${dtb}" "${BASEDIR}/qemu/"
731 fi
731 fi
732 done
732 done
733
733
734 # Copy kernel overlays to QEMU directory
734 # Copy kernel overlays to QEMU directory
735 if [ -d "${BOOT_DIR}/overlays" ] ; then
735 if [ -d "${BOOT_DIR}/overlays" ] ; then
736 # Setup overlays dtbs directory
736 # Setup overlays dtbs directory
737 mkdir "${BASEDIR}/qemu/overlays"
737 mkdir "${BASEDIR}/qemu/overlays"
738
738
739 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
739 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
740 if [ -f "${dtb}" ] ; then
740 if [ -f "${dtb}" ] ; then
741 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
741 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
742 fi
742 fi
743 done
743 done
744 fi
744 fi
745
745
746 # Copy u-boot files to QEMU directory
746 # Copy u-boot files to QEMU directory
747 if [ "$ENABLE_UBOOT" = true ] ; then
747 if [ "$ENABLE_UBOOT" = true ] ; then
748 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
748 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
749 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
749 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
750 fi
750 fi
751 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
751 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
752 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
752 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
753 fi
753 fi
754 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
754 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
755 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
755 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
756 fi
756 fi
757 fi
757 fi
758
758
759 # Copy initramfs to QEMU directory
759 # Copy initramfs to QEMU directory
760 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
760 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
761 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
761 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
762 fi
762 fi
763 fi
763 fi
764
764
765 # Calculate size of the chroot directory in KB
765 # Calculate size of the chroot directory in KB
766 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
766 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
767
767
768 # Calculate the amount of needed 512 Byte sectors
768 # Calculate the amount of needed 512 Byte sectors
769 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
769 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
770 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
770 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
771 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
771 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
772
772
773 # The root partition is EXT4
773 # The root partition is EXT4
774 # This means more space than the actual used space of the chroot is used.
774 # This means more space than the actual used space of the chroot is used.
775 # As overhead for journaling and reserved blocks 35% are added.
775 # As overhead for journaling and reserved blocks 35% are added.
776 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
776 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
777
777
778 # Calculate required image size in 512 Byte sectors
778 # Calculate required image size in 512 Byte sectors
779 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
779 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
780
780
781 # Prepare image file
781 # Prepare image file
782 if [ "$ENABLE_SPLITFS" = true ] ; then
782 if [ "$ENABLE_SPLITFS" = true ] ; then
783 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
783 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
784 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
784 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
785 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
785 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
786 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
786 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
787
787
788 # Write firmware/boot partition tables
788 # Write firmware/boot partition tables
789 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
789 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
790 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
790 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
791 EOM
791 EOM
792
792
793 # Write root partition table
793 # Write root partition table
794 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
794 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
795 ${TABLE_SECTORS},${ROOT_SECTORS},83
795 ${TABLE_SECTORS},${ROOT_SECTORS},83
796 EOM
796 EOM
797
797
798 # Setup temporary loop devices
798 # Setup temporary loop devices
799 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
799 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
800 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
800 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
801 else # ENABLE_SPLITFS=false
801 else # ENABLE_SPLITFS=false
802 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
802 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
803 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
803 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
804
804
805 # Write partition table
805 # Write partition table
806 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
806 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
807 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
807 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
808 ${ROOT_OFFSET},${ROOT_SECTORS},83
808 ${ROOT_OFFSET},${ROOT_SECTORS},83
809 EOM
809 EOM
810
810
811 # Setup temporary loop devices
811 # Setup temporary loop devices
812 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
812 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
813 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
813 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
814 fi
814 fi
815
815
816 if [ "$ENABLE_CRYPTFS" = true ] ; then
816 if [ "$ENABLE_CRYPTFS" = true ] ; then
817 # Create dummy ext4 fs
817 # Create dummy ext4 fs
818 mkfs.ext4 "$ROOT_LOOP"
818 mkfs.ext4 "$ROOT_LOOP"
819
819
820 # Setup password keyfile
820 # Setup password keyfile
821 touch .password
821 touch .password
822 chmod 600 .password
822 chmod 600 .password
823 echo -n ${CRYPTFS_PASSWORD} > .password
823 echo -n ${CRYPTFS_PASSWORD} > .password
824
824
825 # Initialize encrypted partition
825 # Initialize encrypted partition
826 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
826 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
827
827
828 # Open encrypted partition and setup mapping
828 # Open encrypted partition and setup mapping
829 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
829 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
830
830
831 # Secure delete password keyfile
831 # Secure delete password keyfile
832 shred -zu .password
832 shred -zu .password
833
833
834 # Update temporary loop device
834 # Update temporary loop device
835 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
835 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
836
836
837 # Wipe encrypted partition (encryption cipher is used for randomness)
837 # Wipe encrypted partition (encryption cipher is used for randomness)
838 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
838 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
839 fi
839 fi
840
840
841 # Build filesystems
841 # Build filesystems
842 mkfs.vfat "$FRMW_LOOP"
842 mkfs.vfat "$FRMW_LOOP"
843 mkfs.ext4 "$ROOT_LOOP"
843 mkfs.ext4 "$ROOT_LOOP"
844
844
845 # Mount the temporary loop devices
845 # Mount the temporary loop devices
846 mkdir -p "$BUILDDIR/mount"
846 mkdir -p "$BUILDDIR/mount"
847 mount "$ROOT_LOOP" "$BUILDDIR/mount"
847 mount "$ROOT_LOOP" "$BUILDDIR/mount"
848
848
849 mkdir -p "$BUILDDIR/mount/boot/firmware"
849 mkdir -p "$BUILDDIR/mount/boot/firmware"
850 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
850 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
851
851
852 # Copy all files from the chroot to the loop device mount point directory
852 # Copy all files from the chroot to the loop device mount point directory
853 rsync -a "${R}/" "$BUILDDIR/mount/"
853 rsync -a "${R}/" "$BUILDDIR/mount/"
854
854
855 # Unmount all temporary loop devices and mount points
855 # Unmount all temporary loop devices and mount points
856 cleanup
856 cleanup
857
857
858 # Create block map file(s) of image(s)
858 # Create block map file(s) of image(s)
859 if [ "$ENABLE_SPLITFS" = true ] ; then
859 if [ "$ENABLE_SPLITFS" = true ] ; then
860 # Create block map files for "bmaptool"
860 # Create block map files for "bmaptool"
861 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
861 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
862 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
862 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
863
863
864 # Image was successfully created
864 # Image was successfully created
865 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
865 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
866 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
866 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
867 else
867 else
868 # Create block map file for "bmaptool"
868 # Create block map file for "bmaptool"
869 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
869 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
870
870
871 # Image was successfully created
871 # Image was successfully created
872 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
872 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
873
873
874 # Create qemu qcow2 image
874 # Create qemu qcow2 image
875 if [ "$ENABLE_QEMU" = true ] ; then
875 if [ "$ENABLE_QEMU" = true ] ; then
876 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
876 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
877 QEMU_SIZE=16G
877 QEMU_SIZE=16G
878
878
879 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
879 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
880 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
880 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
881
881
882 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
882 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
883 fi
883 fi
884 fi
884 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant